// Copyright 2022 The Accumulate Authors
//
// Use of this source code is governed by an MIT-style
// license that can be found in the LICENSE file or at
// https://opensource.org/licenses/MIT.

package staking

// GENERATED BY go run ./tools/cmd/gen-types. DO NOT EDIT.

//lint:file-ignore S1001,S1002,S1008,SA4013 generated code

import (
	"encoding/json"
	"fmt"
	"math/big"

	"gitlab.com/accumulatenetwork/accumulate/pkg/types/encoding"
	"gitlab.com/accumulatenetwork/accumulate/pkg/url"
)

type AddAccount struct {
	Account  *url.URL    `json:"account,omitempty" form:"account" query:"account" validate:"required"`
	Type     AccountType `json:"type,omitempty" form:"type" query:"type" validate:"required"`
	Payout   *url.URL    `json:"payout,omitempty" form:"payout" query:"payout"`
	Delegate *url.URL    `json:"delegate,omitempty" form:"delegate" query:"delegate"`
}

type CancelRequest struct {
	Request *url.TxID `json:"request,omitempty" form:"request" query:"request" validate:"required"`
}

type ChangeDelegate struct {
	Account  *url.URL `json:"account,omitempty" form:"account" query:"account" validate:"required"`
	Delegate *url.URL `json:"delegate,omitempty" form:"delegate" query:"delegate" validate:"required"`
}

type ChangeDelegatorPayout struct {
	Identity    *url.URL `json:"identity,omitempty" form:"identity" query:"identity" validate:"required"`
	Destination *url.URL `json:"destination,omitempty" form:"destination" query:"destination" validate:"required"`
}

type ChangePayout struct {
	Account     *url.URL `json:"account,omitempty" form:"account" query:"account" validate:"required"`
	Destination *url.URL `json:"destination,omitempty" form:"destination" query:"destination" validate:"required"`
}

type ChangeType struct {
	Account *url.URL    `json:"account,omitempty" form:"account" query:"account" validate:"required"`
	Type    AccountType `json:"type,omitempty" form:"type" query:"type" validate:"required"`
}

type RegisterIdentity struct {
	Identity *url.URL `json:"identity,omitempty" form:"identity" query:"identity" validate:"required"`
}

type RejectDelegates struct {
	Identity *url.URL `json:"identity,omitempty" form:"identity" query:"identity" validate:"required"`
}

type TransferTokens struct {
	Account   *url.URL `json:"account,omitempty" form:"account" query:"account" validate:"required"`
	Recipient *url.URL `json:"recipient,omitempty" form:"recipient" query:"recipient" validate:"required"`
	Amount    *big.Int `json:"amount,omitempty" form:"amount" query:"amount" validate:"required"`
}

type UnstakeAccount struct {
	Account *url.URL `json:"account,omitempty" form:"account" query:"account" validate:"required"`
}

type WithdrawTokens struct {
	Account   *url.URL `json:"account,omitempty" form:"account" query:"account" validate:"required"`
	Recipient *url.URL `json:"recipient,omitempty" form:"recipient" query:"recipient" validate:"required"`
	Amount    *big.Int `json:"amount,omitempty" form:"amount" query:"amount" validate:"required"`
}

func (*AddAccount) ActionType() ActionType { return ActionTypeAddAccount }

func (*CancelRequest) ActionType() ActionType { return ActionTypeCancelRequest }

func (*ChangeDelegate) ActionType() ActionType { return ActionTypeChangeDelegate }

func (*ChangeDelegatorPayout) ActionType() ActionType { return ActionTypeChangeDelegatorPayout }

func (*ChangePayout) ActionType() ActionType { return ActionTypeChangePayout }

func (*ChangeType) ActionType() ActionType { return ActionTypeChangeType }

func (*RegisterIdentity) ActionType() ActionType { return ActionTypeRegisterIdentity }

func (*RejectDelegates) ActionType() ActionType { return ActionTypeRejectDelegates }

func (*TransferTokens) ActionType() ActionType { return ActionTypeTransferTokens }

func (*UnstakeAccount) ActionType() ActionType { return ActionTypeUnstakeAccount }

func (*WithdrawTokens) ActionType() ActionType { return ActionTypeWithdrawTokens }

func (v *AddAccount) Copy() *AddAccount {
	u := new(AddAccount)

	if v.Account != nil {
		u.Account = v.Account
	}
	u.Type = v.Type
	if v.Payout != nil {
		u.Payout = v.Payout
	}
	if v.Delegate != nil {
		u.Delegate = v.Delegate
	}

	return u
}

func (v *AddAccount) CopyAsInterface() interface{} { return v.Copy() }

func (v *CancelRequest) Copy() *CancelRequest {
	u := new(CancelRequest)

	if v.Request != nil {
		u.Request = v.Request
	}

	return u
}

func (v *CancelRequest) CopyAsInterface() interface{} { return v.Copy() }

func (v *ChangeDelegate) Copy() *ChangeDelegate {
	u := new(ChangeDelegate)

	if v.Account != nil {
		u.Account = v.Account
	}
	if v.Delegate != nil {
		u.Delegate = v.Delegate
	}

	return u
}

func (v *ChangeDelegate) CopyAsInterface() interface{} { return v.Copy() }

func (v *ChangeDelegatorPayout) Copy() *ChangeDelegatorPayout {
	u := new(ChangeDelegatorPayout)

	if v.Identity != nil {
		u.Identity = v.Identity
	}
	if v.Destination != nil {
		u.Destination = v.Destination
	}

	return u
}

func (v *ChangeDelegatorPayout) CopyAsInterface() interface{} { return v.Copy() }

func (v *ChangePayout) Copy() *ChangePayout {
	u := new(ChangePayout)

	if v.Account != nil {
		u.Account = v.Account
	}
	if v.Destination != nil {
		u.Destination = v.Destination
	}

	return u
}

func (v *ChangePayout) CopyAsInterface() interface{} { return v.Copy() }

func (v *ChangeType) Copy() *ChangeType {
	u := new(ChangeType)

	if v.Account != nil {
		u.Account = v.Account
	}
	u.Type = v.Type

	return u
}

func (v *ChangeType) CopyAsInterface() interface{} { return v.Copy() }

func (v *RegisterIdentity) Copy() *RegisterIdentity {
	u := new(RegisterIdentity)

	if v.Identity != nil {
		u.Identity = v.Identity
	}

	return u
}

func (v *RegisterIdentity) CopyAsInterface() interface{} { return v.Copy() }

func (v *RejectDelegates) Copy() *RejectDelegates {
	u := new(RejectDelegates)

	if v.Identity != nil {
		u.Identity = v.Identity
	}

	return u
}

func (v *RejectDelegates) CopyAsInterface() interface{} { return v.Copy() }

func (v *TransferTokens) Copy() *TransferTokens {
	u := new(TransferTokens)

	if v.Account != nil {
		u.Account = v.Account
	}
	if v.Recipient != nil {
		u.Recipient = v.Recipient
	}
	if v.Amount != nil {
		u.Amount = encoding.BigintCopy(v.Amount)
	}

	return u
}

func (v *TransferTokens) CopyAsInterface() interface{} { return v.Copy() }

func (v *UnstakeAccount) Copy() *UnstakeAccount {
	u := new(UnstakeAccount)

	if v.Account != nil {
		u.Account = v.Account
	}

	return u
}

func (v *UnstakeAccount) CopyAsInterface() interface{} { return v.Copy() }

func (v *WithdrawTokens) Copy() *WithdrawTokens {
	u := new(WithdrawTokens)

	if v.Account != nil {
		u.Account = v.Account
	}
	if v.Recipient != nil {
		u.Recipient = v.Recipient
	}
	if v.Amount != nil {
		u.Amount = encoding.BigintCopy(v.Amount)
	}

	return u
}

func (v *WithdrawTokens) CopyAsInterface() interface{} { return v.Copy() }

func (v *AddAccount) Equal(u *AddAccount) bool {
	switch {
	case v.Account == u.Account:
		// equal
	case v.Account == nil || u.Account == nil:
		return false
	case !((v.Account).Equal(u.Account)):
		return false
	}
	if !(v.Type == u.Type) {
		return false
	}
	switch {
	case v.Payout == u.Payout:
		// equal
	case v.Payout == nil || u.Payout == nil:
		return false
	case !((v.Payout).Equal(u.Payout)):
		return false
	}
	switch {
	case v.Delegate == u.Delegate:
		// equal
	case v.Delegate == nil || u.Delegate == nil:
		return false
	case !((v.Delegate).Equal(u.Delegate)):
		return false
	}

	return true
}

func (v *CancelRequest) Equal(u *CancelRequest) bool {
	switch {
	case v.Request == u.Request:
		// equal
	case v.Request == nil || u.Request == nil:
		return false
	case !((v.Request).Equal(u.Request)):
		return false
	}

	return true
}

func (v *ChangeDelegate) Equal(u *ChangeDelegate) bool {
	switch {
	case v.Account == u.Account:
		// equal
	case v.Account == nil || u.Account == nil:
		return false
	case !((v.Account).Equal(u.Account)):
		return false
	}
	switch {
	case v.Delegate == u.Delegate:
		// equal
	case v.Delegate == nil || u.Delegate == nil:
		return false
	case !((v.Delegate).Equal(u.Delegate)):
		return false
	}

	return true
}

func (v *ChangeDelegatorPayout) Equal(u *ChangeDelegatorPayout) bool {
	switch {
	case v.Identity == u.Identity:
		// equal
	case v.Identity == nil || u.Identity == nil:
		return false
	case !((v.Identity).Equal(u.Identity)):
		return false
	}
	switch {
	case v.Destination == u.Destination:
		// equal
	case v.Destination == nil || u.Destination == nil:
		return false
	case !((v.Destination).Equal(u.Destination)):
		return false
	}

	return true
}

func (v *ChangePayout) Equal(u *ChangePayout) bool {
	switch {
	case v.Account == u.Account:
		// equal
	case v.Account == nil || u.Account == nil:
		return false
	case !((v.Account).Equal(u.Account)):
		return false
	}
	switch {
	case v.Destination == u.Destination:
		// equal
	case v.Destination == nil || u.Destination == nil:
		return false
	case !((v.Destination).Equal(u.Destination)):
		return false
	}

	return true
}

func (v *ChangeType) Equal(u *ChangeType) bool {
	switch {
	case v.Account == u.Account:
		// equal
	case v.Account == nil || u.Account == nil:
		return false
	case !((v.Account).Equal(u.Account)):
		return false
	}
	if !(v.Type == u.Type) {
		return false
	}

	return true
}

func (v *RegisterIdentity) Equal(u *RegisterIdentity) bool {
	switch {
	case v.Identity == u.Identity:
		// equal
	case v.Identity == nil || u.Identity == nil:
		return false
	case !((v.Identity).Equal(u.Identity)):
		return false
	}

	return true
}

func (v *RejectDelegates) Equal(u *RejectDelegates) bool {
	switch {
	case v.Identity == u.Identity:
		// equal
	case v.Identity == nil || u.Identity == nil:
		return false
	case !((v.Identity).Equal(u.Identity)):
		return false
	}

	return true
}

func (v *TransferTokens) Equal(u *TransferTokens) bool {
	switch {
	case v.Account == u.Account:
		// equal
	case v.Account == nil || u.Account == nil:
		return false
	case !((v.Account).Equal(u.Account)):
		return false
	}
	switch {
	case v.Recipient == u.Recipient:
		// equal
	case v.Recipient == nil || u.Recipient == nil:
		return false
	case !((v.Recipient).Equal(u.Recipient)):
		return false
	}
	switch {
	case v.Amount == u.Amount:
		// equal
	case v.Amount == nil || u.Amount == nil:
		return false
	case !((v.Amount).Cmp(u.Amount) == 0):
		return false
	}

	return true
}

func (v *UnstakeAccount) Equal(u *UnstakeAccount) bool {
	switch {
	case v.Account == u.Account:
		// equal
	case v.Account == nil || u.Account == nil:
		return false
	case !((v.Account).Equal(u.Account)):
		return false
	}

	return true
}

func (v *WithdrawTokens) Equal(u *WithdrawTokens) bool {
	switch {
	case v.Account == u.Account:
		// equal
	case v.Account == nil || u.Account == nil:
		return false
	case !((v.Account).Equal(u.Account)):
		return false
	}
	switch {
	case v.Recipient == u.Recipient:
		// equal
	case v.Recipient == nil || u.Recipient == nil:
		return false
	case !((v.Recipient).Equal(u.Recipient)):
		return false
	}
	switch {
	case v.Amount == u.Amount:
		// equal
	case v.Amount == nil || u.Amount == nil:
		return false
	case !((v.Amount).Cmp(u.Amount) == 0):
		return false
	}

	return true
}

func init() {

	encoding.RegisterTypeDefinition(&[]*encoding.TypeField{
		encoding.NewTypeField("actionType", "string"),
		encoding.NewTypeField("account", "string"),
		encoding.NewTypeField("type", "string"),
		encoding.NewTypeField("payout", "string"),
		encoding.NewTypeField("delegate", "string"),
	}, "AddAccount", "addAccount")

	encoding.RegisterTypeDefinition(&[]*encoding.TypeField{
		encoding.NewTypeField("actionType", "string"),
		encoding.NewTypeField("request", "string"),
	}, "CancelRequest", "cancelRequest")

	encoding.RegisterTypeDefinition(&[]*encoding.TypeField{
		encoding.NewTypeField("actionType", "string"),
		encoding.NewTypeField("account", "string"),
		encoding.NewTypeField("delegate", "string"),
	}, "ChangeDelegate", "changeDelegate")

	encoding.RegisterTypeDefinition(&[]*encoding.TypeField{
		encoding.NewTypeField("actionType", "string"),
		encoding.NewTypeField("identity", "string"),
		encoding.NewTypeField("destination", "string"),
	}, "ChangeDelegatorPayout", "changeDelegatorPayout")

	encoding.RegisterTypeDefinition(&[]*encoding.TypeField{
		encoding.NewTypeField("actionType", "string"),
		encoding.NewTypeField("account", "string"),
		encoding.NewTypeField("destination", "string"),
	}, "ChangePayout", "changePayout")

	encoding.RegisterTypeDefinition(&[]*encoding.TypeField{
		encoding.NewTypeField("actionType", "string"),
		encoding.NewTypeField("account", "string"),
		encoding.NewTypeField("type", "string"),
	}, "ChangeType", "changeType")

	encoding.RegisterTypeDefinition(&[]*encoding.TypeField{
		encoding.NewTypeField("actionType", "string"),
		encoding.NewTypeField("identity", "string"),
	}, "RegisterIdentity", "registerIdentity")

	encoding.RegisterTypeDefinition(&[]*encoding.TypeField{
		encoding.NewTypeField("actionType", "string"),
		encoding.NewTypeField("identity", "string"),
	}, "RejectDelegates", "rejectDelegates")

	encoding.RegisterTypeDefinition(&[]*encoding.TypeField{
		encoding.NewTypeField("actionType", "string"),
		encoding.NewTypeField("account", "string"),
		encoding.NewTypeField("recipient", "string"),
		encoding.NewTypeField("amount", "uint256"),
	}, "TransferTokens", "transferTokens")

	encoding.RegisterTypeDefinition(&[]*encoding.TypeField{
		encoding.NewTypeField("actionType", "string"),
		encoding.NewTypeField("account", "string"),
	}, "UnstakeAccount", "unstakeAccount")

	encoding.RegisterTypeDefinition(&[]*encoding.TypeField{
		encoding.NewTypeField("actionType", "string"),
		encoding.NewTypeField("account", "string"),
		encoding.NewTypeField("recipient", "string"),
		encoding.NewTypeField("amount", "uint256"),
	}, "WithdrawTokens", "withdrawTokens")

}

func (v *AddAccount) MarshalJSON() ([]byte, error) {
	u := struct {
		ActionType ActionType  `json:"actionType"`
		Account    *url.URL    `json:"account,omitempty"`
		Type       AccountType `json:"type,omitempty"`
		Payout     *url.URL    `json:"payout,omitempty"`
		Delegate   *url.URL    `json:"delegate,omitempty"`
	}{}
	u.ActionType = v.ActionType()
	if !(v.Account == nil) {
		u.Account = v.Account
	}
	if !(v.Type == 0) {
		u.Type = v.Type
	}
	if !(v.Payout == nil) {
		u.Payout = v.Payout
	}
	if !(v.Delegate == nil) {
		u.Delegate = v.Delegate
	}
	return json.Marshal(&u)
}

func (v *CancelRequest) MarshalJSON() ([]byte, error) {
	u := struct {
		ActionType ActionType `json:"actionType"`
		Request    *url.TxID  `json:"request,omitempty"`
	}{}
	u.ActionType = v.ActionType()
	if !(v.Request == nil) {
		u.Request = v.Request
	}
	return json.Marshal(&u)
}

func (v *ChangeDelegate) MarshalJSON() ([]byte, error) {
	u := struct {
		ActionType ActionType `json:"actionType"`
		Account    *url.URL   `json:"account,omitempty"`
		Delegate   *url.URL   `json:"delegate,omitempty"`
	}{}
	u.ActionType = v.ActionType()
	if !(v.Account == nil) {
		u.Account = v.Account
	}
	if !(v.Delegate == nil) {
		u.Delegate = v.Delegate
	}
	return json.Marshal(&u)
}

func (v *ChangeDelegatorPayout) MarshalJSON() ([]byte, error) {
	u := struct {
		ActionType  ActionType `json:"actionType"`
		Identity    *url.URL   `json:"identity,omitempty"`
		Destination *url.URL   `json:"destination,omitempty"`
	}{}
	u.ActionType = v.ActionType()
	if !(v.Identity == nil) {
		u.Identity = v.Identity
	}
	if !(v.Destination == nil) {
		u.Destination = v.Destination
	}
	return json.Marshal(&u)
}

func (v *ChangePayout) MarshalJSON() ([]byte, error) {
	u := struct {
		ActionType  ActionType `json:"actionType"`
		Account     *url.URL   `json:"account,omitempty"`
		Destination *url.URL   `json:"destination,omitempty"`
	}{}
	u.ActionType = v.ActionType()
	if !(v.Account == nil) {
		u.Account = v.Account
	}
	if !(v.Destination == nil) {
		u.Destination = v.Destination
	}
	return json.Marshal(&u)
}

func (v *ChangeType) MarshalJSON() ([]byte, error) {
	u := struct {
		ActionType ActionType  `json:"actionType"`
		Account    *url.URL    `json:"account,omitempty"`
		Type       AccountType `json:"type,omitempty"`
	}{}
	u.ActionType = v.ActionType()
	if !(v.Account == nil) {
		u.Account = v.Account
	}
	if !(v.Type == 0) {
		u.Type = v.Type
	}
	return json.Marshal(&u)
}

func (v *RegisterIdentity) MarshalJSON() ([]byte, error) {
	u := struct {
		ActionType ActionType `json:"actionType"`
		Identity   *url.URL   `json:"identity,omitempty"`
	}{}
	u.ActionType = v.ActionType()
	if !(v.Identity == nil) {
		u.Identity = v.Identity
	}
	return json.Marshal(&u)
}

func (v *RejectDelegates) MarshalJSON() ([]byte, error) {
	u := struct {
		ActionType ActionType `json:"actionType"`
		Identity   *url.URL   `json:"identity,omitempty"`
	}{}
	u.ActionType = v.ActionType()
	if !(v.Identity == nil) {
		u.Identity = v.Identity
	}
	return json.Marshal(&u)
}

func (v *TransferTokens) MarshalJSON() ([]byte, error) {
	u := struct {
		ActionType ActionType `json:"actionType"`
		Account    *url.URL   `json:"account,omitempty"`
		Recipient  *url.URL   `json:"recipient,omitempty"`
		Amount     *string    `json:"amount,omitempty"`
	}{}
	u.ActionType = v.ActionType()
	if !(v.Account == nil) {
		u.Account = v.Account
	}
	if !(v.Recipient == nil) {
		u.Recipient = v.Recipient
	}
	if !(v.Amount == nil) {
		u.Amount = encoding.BigintToJSON(v.Amount)
	}
	return json.Marshal(&u)
}

func (v *UnstakeAccount) MarshalJSON() ([]byte, error) {
	u := struct {
		ActionType ActionType `json:"actionType"`
		Account    *url.URL   `json:"account,omitempty"`
	}{}
	u.ActionType = v.ActionType()
	if !(v.Account == nil) {
		u.Account = v.Account
	}
	return json.Marshal(&u)
}

func (v *WithdrawTokens) MarshalJSON() ([]byte, error) {
	u := struct {
		ActionType ActionType `json:"actionType"`
		Account    *url.URL   `json:"account,omitempty"`
		Recipient  *url.URL   `json:"recipient,omitempty"`
		Amount     *string    `json:"amount,omitempty"`
	}{}
	u.ActionType = v.ActionType()
	if !(v.Account == nil) {
		u.Account = v.Account
	}
	if !(v.Recipient == nil) {
		u.Recipient = v.Recipient
	}
	if !(v.Amount == nil) {
		u.Amount = encoding.BigintToJSON(v.Amount)
	}
	return json.Marshal(&u)
}

func (v *AddAccount) UnmarshalJSON(data []byte) error {
	u := struct {
		ActionType ActionType  `json:"actionType"`
		Account    *url.URL    `json:"account,omitempty"`
		Type       AccountType `json:"type,omitempty"`
		Payout     *url.URL    `json:"payout,omitempty"`
		Delegate   *url.URL    `json:"delegate,omitempty"`
	}{}
	u.ActionType = v.ActionType()
	u.Account = v.Account
	u.Type = v.Type
	u.Payout = v.Payout
	u.Delegate = v.Delegate
	err := json.Unmarshal(data, &u)
	if err != nil {
		return err
	}
	if !(v.ActionType() == u.ActionType) {
		return fmt.Errorf("field ActionType: not equal: want %v, got %v", v.ActionType(), u.ActionType)
	}
	v.Account = u.Account
	v.Type = u.Type
	v.Payout = u.Payout
	v.Delegate = u.Delegate
	return nil
}

func (v *CancelRequest) UnmarshalJSON(data []byte) error {
	u := struct {
		ActionType ActionType `json:"actionType"`
		Request    *url.TxID  `json:"request,omitempty"`
	}{}
	u.ActionType = v.ActionType()
	u.Request = v.Request
	err := json.Unmarshal(data, &u)
	if err != nil {
		return err
	}
	if !(v.ActionType() == u.ActionType) {
		return fmt.Errorf("field ActionType: not equal: want %v, got %v", v.ActionType(), u.ActionType)
	}
	v.Request = u.Request
	return nil
}

func (v *ChangeDelegate) UnmarshalJSON(data []byte) error {
	u := struct {
		ActionType ActionType `json:"actionType"`
		Account    *url.URL   `json:"account,omitempty"`
		Delegate   *url.URL   `json:"delegate,omitempty"`
	}{}
	u.ActionType = v.ActionType()
	u.Account = v.Account
	u.Delegate = v.Delegate
	err := json.Unmarshal(data, &u)
	if err != nil {
		return err
	}
	if !(v.ActionType() == u.ActionType) {
		return fmt.Errorf("field ActionType: not equal: want %v, got %v", v.ActionType(), u.ActionType)
	}
	v.Account = u.Account
	v.Delegate = u.Delegate
	return nil
}

func (v *ChangeDelegatorPayout) UnmarshalJSON(data []byte) error {
	u := struct {
		ActionType  ActionType `json:"actionType"`
		Identity    *url.URL   `json:"identity,omitempty"`
		Destination *url.URL   `json:"destination,omitempty"`
	}{}
	u.ActionType = v.ActionType()
	u.Identity = v.Identity
	u.Destination = v.Destination
	err := json.Unmarshal(data, &u)
	if err != nil {
		return err
	}
	if !(v.ActionType() == u.ActionType) {
		return fmt.Errorf("field ActionType: not equal: want %v, got %v", v.ActionType(), u.ActionType)
	}
	v.Identity = u.Identity
	v.Destination = u.Destination
	return nil
}

func (v *ChangePayout) UnmarshalJSON(data []byte) error {
	u := struct {
		ActionType  ActionType `json:"actionType"`
		Account     *url.URL   `json:"account,omitempty"`
		Destination *url.URL   `json:"destination,omitempty"`
	}{}
	u.ActionType = v.ActionType()
	u.Account = v.Account
	u.Destination = v.Destination
	err := json.Unmarshal(data, &u)
	if err != nil {
		return err
	}
	if !(v.ActionType() == u.ActionType) {
		return fmt.Errorf("field ActionType: not equal: want %v, got %v", v.ActionType(), u.ActionType)
	}
	v.Account = u.Account
	v.Destination = u.Destination
	return nil
}

func (v *ChangeType) UnmarshalJSON(data []byte) error {
	u := struct {
		ActionType ActionType  `json:"actionType"`
		Account    *url.URL    `json:"account,omitempty"`
		Type       AccountType `json:"type,omitempty"`
	}{}
	u.ActionType = v.ActionType()
	u.Account = v.Account
	u.Type = v.Type
	err := json.Unmarshal(data, &u)
	if err != nil {
		return err
	}
	if !(v.ActionType() == u.ActionType) {
		return fmt.Errorf("field ActionType: not equal: want %v, got %v", v.ActionType(), u.ActionType)
	}
	v.Account = u.Account
	v.Type = u.Type
	return nil
}

func (v *RegisterIdentity) UnmarshalJSON(data []byte) error {
	u := struct {
		ActionType ActionType `json:"actionType"`
		Identity   *url.URL   `json:"identity,omitempty"`
	}{}
	u.ActionType = v.ActionType()
	u.Identity = v.Identity
	err := json.Unmarshal(data, &u)
	if err != nil {
		return err
	}
	if !(v.ActionType() == u.ActionType) {
		return fmt.Errorf("field ActionType: not equal: want %v, got %v", v.ActionType(), u.ActionType)
	}
	v.Identity = u.Identity
	return nil
}

func (v *RejectDelegates) UnmarshalJSON(data []byte) error {
	u := struct {
		ActionType ActionType `json:"actionType"`
		Identity   *url.URL   `json:"identity,omitempty"`
	}{}
	u.ActionType = v.ActionType()
	u.Identity = v.Identity
	err := json.Unmarshal(data, &u)
	if err != nil {
		return err
	}
	if !(v.ActionType() == u.ActionType) {
		return fmt.Errorf("field ActionType: not equal: want %v, got %v", v.ActionType(), u.ActionType)
	}
	v.Identity = u.Identity
	return nil
}

func (v *TransferTokens) UnmarshalJSON(data []byte) error {
	u := struct {
		ActionType ActionType `json:"actionType"`
		Account    *url.URL   `json:"account,omitempty"`
		Recipient  *url.URL   `json:"recipient,omitempty"`
		Amount     *string    `json:"amount,omitempty"`
	}{}
	u.ActionType = v.ActionType()
	u.Account = v.Account
	u.Recipient = v.Recipient
	u.Amount = encoding.BigintToJSON(v.Amount)
	err := json.Unmarshal(data, &u)
	if err != nil {
		return err
	}
	if !(v.ActionType() == u.ActionType) {
		return fmt.Errorf("field ActionType: not equal: want %v, got %v", v.ActionType(), u.ActionType)
	}
	v.Account = u.Account
	v.Recipient = u.Recipient
	if u.Amount != nil {
		if x, err := encoding.BigintFromJSON(u.Amount); err != nil {
			return fmt.Errorf("error decoding Amount: %w", err)
		} else {
			v.Amount = x
		}
	}
	return nil
}

func (v *UnstakeAccount) UnmarshalJSON(data []byte) error {
	u := struct {
		ActionType ActionType `json:"actionType"`
		Account    *url.URL   `json:"account,omitempty"`
	}{}
	u.ActionType = v.ActionType()
	u.Account = v.Account
	err := json.Unmarshal(data, &u)
	if err != nil {
		return err
	}
	if !(v.ActionType() == u.ActionType) {
		return fmt.Errorf("field ActionType: not equal: want %v, got %v", v.ActionType(), u.ActionType)
	}
	v.Account = u.Account
	return nil
}

func (v *WithdrawTokens) UnmarshalJSON(data []byte) error {
	u := struct {
		ActionType ActionType `json:"actionType"`
		Account    *url.URL   `json:"account,omitempty"`
		Recipient  *url.URL   `json:"recipient,omitempty"`
		Amount     *string    `json:"amount,omitempty"`
	}{}
	u.ActionType = v.ActionType()
	u.Account = v.Account
	u.Recipient = v.Recipient
	u.Amount = encoding.BigintToJSON(v.Amount)
	err := json.Unmarshal(data, &u)
	if err != nil {
		return err
	}
	if !(v.ActionType() == u.ActionType) {
		return fmt.Errorf("field ActionType: not equal: want %v, got %v", v.ActionType(), u.ActionType)
	}
	v.Account = u.Account
	v.Recipient = u.Recipient
	if u.Amount != nil {
		if x, err := encoding.BigintFromJSON(u.Amount); err != nil {
			return fmt.Errorf("error decoding Amount: %w", err)
		} else {
			v.Amount = x
		}
	}
	return nil
}
